# Generated by Django 4.2.5 on 2024-01-18 16:42

from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion
import encrypted_json_fields.fields
import users.shortcuts


class Migration(migrations.Migration):
    initial = True

    dependencies = [
        ("vms", "0001_initial"),
        ("schedule", "0001_initial"),
        ("credentials", "0001_initial"),
        ("tasks", "0001_initial"),
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.CreateModel(
            name="Backup",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("name", models.CharField(max_length=64)),
                (
                    "description",
                    models.CharField(blank=True, default="", max_length=2048),
                ),
                ("last_snapshot_id", models.IntegerField(null=True)),
                ("last_started_time", models.DateTimeField(null=True)),
                ("last_finished_time", models.DateTimeField(null=True)),
                ("last_started_localtime", models.DateTimeField(null=True)),
                ("last_finished_localtime", models.DateTimeField(null=True)),
                (
                    "target_type",
                    models.CharField(
                        choices=[
                            ("local", "Local Backup"),
                            ("remote", "Remote Backup"),
                        ],
                        max_length=8,
                    ),
                ),
                ("target_path", models.CharField(max_length=4096)),
                (
                    "strategy",
                    models.CharField(
                        choices=[
                            ("full", "Full Backup"),
                            ("incremental", "Incremental Backup"),
                        ],
                        default="incremental",
                        max_length=16,
                    ),
                ),
                ("restore_only", models.BooleanField(default=False)),
                ("retention", models.IntegerField(null=True)),
                ("error_message", models.TextField(null=True)),
                (
                    "credential",
                    models.ForeignKey(
                        null=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="backups",
                        to="credentials.credential",
                    ),
                ),
                (
                    "schedule",
                    models.ForeignKey(
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="backups",
                        to="schedule.schedule",
                    ),
                ),
                (
                    "user",
                    models.ForeignKey(
                        on_delete=models.SET(users.shortcuts.get_admin_user),
                        related_name="backups",
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
                (
                    "vm",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="backups",
                        to="vms.vm",
                    ),
                ),
            ],
            options={
                "abstract": False,
            },
        ),
        migrations.CreateModel(
            name="RemoteBackupTask",
            fields=[
                (
                    "task_ptr",
                    models.OneToOneField(
                        auto_created=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        parent_link=True,
                        primary_key=True,
                        serialize=False,
                        to="tasks.task",
                    ),
                ),
                ("name", models.CharField(max_length=64)),
                ("target_path", models.CharField(max_length=4096)),
                (
                    "strategy",
                    models.CharField(
                        choices=[
                            ("full", "Full Backup"),
                            ("incremental", "Incremental Backup"),
                        ],
                        max_length=16,
                    ),
                ),
                ("retention", models.IntegerField(null=True)),
                ("hostname", models.CharField(max_length=255)),
                ("username", models.CharField(max_length=32)),
                (
                    "password",
                    encrypted_json_fields.fields.EncryptedCharField(),
                ),
                ("port", models.IntegerField(default=80)),
                (
                    "protocol",
                    models.CharField(
                        choices=[("http", "HTTP"), ("https", "HTTPS")],
                        default="http",
                        max_length=32,
                    ),
                ),
                (
                    "backup",
                    models.ForeignKey(
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="remote_backup_tasks",
                        to="backups.backup",
                    ),
                ),
                (
                    "vm",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="remote_backup_tasks",
                        to="vms.vm",
                    ),
                ),
            ],
            options={
                "abstract": False,
            },
            bases=("tasks.task",),
        ),
        migrations.CreateModel(
            name="Remote",
            fields=[
                (
                    "task_ptr",
                    models.OneToOneField(
                        auto_created=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        parent_link=True,
                        primary_key=True,
                        serialize=False,
                        to="tasks.task",
                    ),
                ),
                (
                    "method",
                    models.CharField(
                        choices=[
                            ("copy", "Copy form the backup path"),
                            ("move", "Move from the backup path"),
                        ],
                        default="copy",
                        max_length=10,
                    ),
                ),
                ("vm_settings", models.JSONField(null=True)),
                ("target_path", models.CharField(max_length=4096)),
                ("source_path", models.CharField(max_length=4096)),
                ("hostname", models.CharField(max_length=255)),
                ("username", models.CharField(max_length=32)),
                (
                    "password",
                    encrypted_json_fields.fields.EncryptedCharField(),
                ),
                ("port", models.IntegerField(default=80)),
                ("protocol", models.CharField(default="http", max_length=32)),
                (
                    "vm",
                    models.ForeignKey(
                        null=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        to="vms.vm",
                    ),
                ),
            ],
            options={
                "abstract": False,
            },
            bases=("tasks.task",),
        ),
        migrations.CreateModel(
            name="LocalBackupTask",
            fields=[
                (
                    "task_ptr",
                    models.OneToOneField(
                        auto_created=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        parent_link=True,
                        primary_key=True,
                        serialize=False,
                        to="tasks.task",
                    ),
                ),
                ("name", models.CharField(max_length=64)),
                ("target_path", models.CharField(max_length=4096)),
                (
                    "strategy",
                    models.CharField(
                        choices=[
                            ("full", "Full Backup"),
                            ("incremental", "Incremental Backup"),
                        ],
                        max_length=16,
                    ),
                ),
                ("retention", models.IntegerField(null=True)),
                (
                    "backup",
                    models.ForeignKey(
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="local_backup_tasks",
                        to="backups.backup",
                    ),
                ),
                (
                    "vm",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="local_backup_tasks",
                        to="vms.vm",
                    ),
                ),
            ],
            options={
                "abstract": False,
            },
            bases=("tasks.task",),
        ),
        migrations.CreateModel(
            name="Local",
            fields=[
                (
                    "task_ptr",
                    models.OneToOneField(
                        auto_created=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        parent_link=True,
                        primary_key=True,
                        serialize=False,
                        to="tasks.task",
                    ),
                ),
                (
                    "method",
                    models.CharField(
                        choices=[
                            ("copy", "Copy form the backup path"),
                            ("move", "Move from the backup path"),
                        ],
                        default="copy",
                        max_length=10,
                    ),
                ),
                ("vm_settings", models.JSONField(null=True)),
                ("target_path", models.CharField(max_length=4096)),
                ("source_path", models.CharField(max_length=4096)),
                (
                    "vm",
                    models.ForeignKey(
                        null=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        to="vms.vm",
                    ),
                ),
            ],
            options={
                "abstract": False,
            },
            bases=("tasks.task",),
        ),
    ]
