# Generated by Django 4.2.5 on 2024-01-18 18:09

from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion

from vs.utils.time import get_utc_time


class Migration(migrations.Migration):
    initial = True

    dependencies = [
        ("vms", "0001_initial"),
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.CreateModel(
            name="LogCategory",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("name", models.CharField(default="", max_length=50)),
            ],
            options={
                "abstract": False,
            },
        ),
        migrations.CreateModel(
            name="Log",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("msg_id", models.IntegerField(null=True)),
                ("message", models.TextField()),
                ("message_en", models.TextField()),
                ("data", models.JSONField(null=True)),
                ("error_message", models.TextField(default="")),
                (
                    "severity",
                    models.CharField(
                        choices=[
                            ("info", "Information"),
                            ("warn", "Warning"),
                            ("error", "Error"),
                        ],
                        default="info",
                        max_length=5,
                    ),
                ),
                ("username", models.CharField(max_length=30, null=True)),
                ("vm_name", models.CharField(max_length=64, null=True)),
                ("file", models.JSONField(null=True)),
                ("notify", models.BooleanField(default=False)),
                (
                    "category",
                    models.ForeignKey(
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="logs",
                        to="logs.logcategory",
                    ),
                ),
                (
                    "user",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="logs",
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
                (
                    "vm",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="logs",
                        to="vms.vm",
                    ),
                ),
                ("time", models.DateTimeField(default=get_utc_time)),
            ],
            options={
                "abstract": False,
            },
        ),
    ]
