# Generated by Django 4.2.5 on 2024-01-18 16:42

from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion
import users.shortcuts


class Migration(migrations.Migration):
    initial = True

    dependencies = [
        ("contenttypes", "0002_remove_content_type_name"),
        ("vms", "0001_initial"),
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.CreateModel(
            name="Schedule",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "frequency",
                    models.CharField(
                        choices=[
                            ("o", "one shot"),
                            ("M", "minutely"),
                            ("h", "hourly"),
                            ("d", "daily"),
                            ("w", "weekly"),
                            ("m", "monthly"),
                        ],
                        max_length=10,
                    ),
                ),
                ("interval", models.IntegerField(null=True)),
                ("hour", models.IntegerField()),
                ("minute", models.IntegerField()),
                ("days", models.JSONField(null=True)),
                ("sdate", models.DateField(null=True)),
                ("enable", models.BooleanField(default=True)),
                ("job_id", models.PositiveIntegerField()),
                ("job_action", models.CharField(max_length=100)),
                (
                    "job_model",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to="contenttypes.contenttype",
                    ),
                ),
            ],
            options={
                "abstract": False,
            },
        ),
        migrations.CreateModel(
            name="ScheduleSnapshot",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("name", models.CharField(max_length=32)),
                (
                    "description",
                    models.CharField(blank=True, default="", max_length=2048),
                ),
                ("last_started_time", models.DateTimeField(null=True)),
                ("last_finished_time", models.DateTimeField(null=True)),
                ("last_started_localtime", models.DateTimeField(null=True)),
                ("last_finished_localtime", models.DateTimeField(null=True)),
                ("error_message", models.TextField(null=True)),
                (
                    "schedule",
                    models.ForeignKey(
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="schedulesnapshot",
                        to="schedule.schedule",
                    ),
                ),
                (
                    "user",
                    models.ForeignKey(
                        on_delete=models.SET(users.shortcuts.get_admin_user),
                        related_name="schedulesnapshot",
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
                (
                    "vm",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="schedulesnapshot",
                        to="vms.vm",
                    ),
                ),
            ],
            options={
                "abstract": False,
            },
        ),
    ]
