# Generated by Django 4.2.5 on 2024-01-18 16:27

import django.db.models.deletion
from django.conf import settings
from django.db import migrations, models

from vs.utils.time import get_utc_time


class Migration(migrations.Migration):
    initial = True

    dependencies = [
        ("contenttypes", "0002_remove_content_type_name"),
        ("images", "0001_initial"),
        ("vms", "0001_initial"),
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.CreateModel(
            name="Task",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "state",
                    models.CharField(
                        choices=[
                            ("waiting", "waiting"),
                            ("running", "running"),
                            ("clearing", "clearing"),
                        ],
                        default="waiting",
                        max_length=16,
                    ),
                ),
                ("title", models.CharField(max_length=64)),
                ("data", models.JSONField(default=dict)),
                (
                    "task_queue_name",
                    models.CharField(default="task", max_length=64),
                ),
                ("creation_time", models.DateTimeField(default=get_utc_time)),
                (
                    "real_type",
                    models.ForeignKey(
                        editable=False,
                        on_delete=django.db.models.deletion.CASCADE,
                        to="contenttypes.contenttype",
                    ),
                ),
                (
                    "user",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="tasks",
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
            ],
            options={
                "abstract": False,
            },
        ),
        migrations.CreateModel(
            name="BanIpTask",
            fields=[
                (
                    "task_ptr",
                    models.OneToOneField(
                        auto_created=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        parent_link=True,
                        primary_key=True,
                        serialize=False,
                        to="tasks.task",
                    ),
                ),
                ("ip", models.GenericIPAddressField(unpack_ipv4=True)),
                (
                    "ip_type",
                    models.IntegerField(
                        choices=[
                            (0, "single ip"),
                            (1, "subnet"),
                            (2, "range of ips respectively"),
                        ],
                        default=0,
                    ),
                ),
                ("interval", models.IntegerField()),
                ("max_login_times", models.IntegerField()),
                (
                    "keep_block_interval",
                    models.IntegerField(
                        choices=[
                            (0, "forever"),
                            (5, "5 min"),
                            (30, "30 min"),
                            (60, "1 hour"),
                            (1440, "1 day"),
                        ],
                        default=5,
                    ),
                ),
                ("start_ban_timestamp", models.IntegerField()),
            ],
            options={
                "abstract": False,
            },
            bases=("tasks.task",),
        ),
        migrations.CreateModel(
            name="DownloadISOTask",
            fields=[
                (
                    "task_ptr",
                    models.OneToOneField(
                        auto_created=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        parent_link=True,
                        primary_key=True,
                        serialize=False,
                        to="tasks.task",
                    ),
                ),
            ],
            options={
                "abstract": False,
            },
            bases=("tasks.task",),
        ),
        migrations.CreateModel(
            name="GeneralTask",
            fields=[
                (
                    "task_ptr",
                    models.OneToOneField(
                        auto_created=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        parent_link=True,
                        primary_key=True,
                        serialize=False,
                        to="tasks.task",
                    ),
                ),
                (
                    "description",
                    models.CharField(blank=True, max_length=64, null=True),
                ),
                ("gtask_type", models.CharField(max_length=64)),
                ("gtask_data", models.JSONField(default=dict)),
            ],
            options={
                "abstract": False,
            },
            bases=("tasks.task",),
        ),
        migrations.CreateModel(
            name="ImageConversionTask",
            fields=[
                (
                    "task_ptr",
                    models.OneToOneField(
                        auto_created=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        parent_link=True,
                        primary_key=True,
                        serialize=False,
                        to="tasks.task",
                    ),
                ),
                ("src", models.CharField(max_length=4096)),
                ("dst", models.CharField(max_length=4096)),
                ("dst_fmt", models.CharField(max_length=20)),
                ("dst_opts", models.CharField(max_length=4096, null=True)),
                ("snapshot_id", models.CharField(max_length=4096, null=True)),
            ],
            options={
                "abstract": False,
            },
            bases=("tasks.task",),
        ),
        migrations.CreateModel(
            name="ImportVMTask",
            fields=[
                (
                    "task_ptr",
                    models.OneToOneField(
                        auto_created=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        parent_link=True,
                        primary_key=True,
                        serialize=False,
                        to="tasks.task",
                    ),
                ),
            ],
            options={
                "abstract": False,
            },
            bases=("tasks.task",),
        ),
        migrations.CreateModel(
            name="MigrationInTask",
            fields=[
                (
                    "task_ptr",
                    models.OneToOneField(
                        auto_created=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        parent_link=True,
                        primary_key=True,
                        serialize=False,
                        to="tasks.task",
                    ),
                ),
                (
                    "uuid",
                    models.CharField(max_length=36, null=True, unique=True),
                ),
                ("vm_name", models.CharField(max_length=64)),
            ],
            options={
                "abstract": False,
            },
            bases=("tasks.task",),
        ),
        migrations.CreateModel(
            name="MigrationOutTask",
            fields=[
                (
                    "task_ptr",
                    models.OneToOneField(
                        auto_created=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        parent_link=True,
                        primary_key=True,
                        serialize=False,
                        to="tasks.task",
                    ),
                ),
            ],
            options={
                "abstract": False,
            },
            bases=("tasks.task",),
        ),
        migrations.CreateModel(
            name="UploadFileTask",
            fields=[
                (
                    "task_ptr",
                    models.OneToOneField(
                        auto_created=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        parent_link=True,
                        primary_key=True,
                        serialize=False,
                        to="tasks.task",
                    ),
                ),
                ("file_name", models.CharField(max_length=64)),
                (
                    "file_directory",
                    models.CharField(default="", max_length=4096),
                ),
            ],
            options={
                "abstract": False,
            },
            bases=("tasks.task",),
        ),
        migrations.CreateModel(
            name="SuspendVMTask",
            fields=[
                (
                    "task_ptr",
                    models.OneToOneField(
                        auto_created=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        parent_link=True,
                        primary_key=True,
                        serialize=False,
                        to="tasks.task",
                    ),
                ),
                (
                    "vm",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="suspend_vm_tasks",
                        to="vms.vm",
                    ),
                ),
            ],
            options={
                "abstract": False,
            },
            bases=("tasks.task",),
        ),
        migrations.CreateModel(
            name="ImageTask",
            fields=[
                (
                    "task_ptr",
                    models.OneToOneField(
                        auto_created=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        parent_link=True,
                        primary_key=True,
                        serialize=False,
                        to="tasks.task",
                    ),
                ),
                ("source_path", models.CharField(default="", max_length=4096)),
                ("target_path", models.CharField(default="", max_length=4096)),
                (
                    "action_type",
                    models.CharField(
                        choices=[("create", "create"), ("update", "update")],
                        default="create",
                        max_length=10,
                    ),
                ),
                (
                    "source_type",
                    models.CharField(
                        choices=[
                            ("pc", "pc"),
                            ("local", "local"),
                            ("remote", "remote"),
                        ],
                        default="local",
                        max_length=10,
                    ),
                ),
                (
                    "image",
                    models.ForeignKey(
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="image_tasks",
                        to="images.image",
                    ),
                ),
            ],
            options={
                "abstract": False,
            },
            bases=("tasks.task",),
        ),
        migrations.CreateModel(
            name="ExportVMTask",
            fields=[
                (
                    "task_ptr",
                    models.OneToOneField(
                        auto_created=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        parent_link=True,
                        primary_key=True,
                        serialize=False,
                        to="tasks.task",
                    ),
                ),
                ("file_name", models.CharField(max_length=64)),
                (
                    "export_directory",
                    models.CharField(default="", max_length=4096),
                ),
                (
                    "temporary_directory",
                    models.CharField(default="", max_length=4096),
                ),
                (
                    "export_format",
                    models.CharField(
                        choices=[
                            ("qvm", "qvm"),
                            ("ovf", "ovf"),
                            ("vhdx", "vhdx"),
                        ],
                        default="qvm",
                        max_length=32,
                    ),
                ),
                ("export_iso", models.IntegerField(default=0, null=True)),
                ("compress", models.IntegerField(default=0, null=True)),
                ("stage_progress", models.FloatField(default=0.0, null=True)),
                ("stages", models.CharField(default="", max_length=4096)),
                (
                    "vm",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="export_tasks",
                        to="vms.vm",
                    ),
                ),
            ],
            options={
                "abstract": False,
            },
            bases=("tasks.task",),
        ),
        migrations.CreateModel(
            name="DeleteSnapshotTask",
            fields=[
                (
                    "task_ptr",
                    models.OneToOneField(
                        auto_created=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        parent_link=True,
                        primary_key=True,
                        serialize=False,
                        to="tasks.task",
                    ),
                ),
                ("snapshot_id", models.IntegerField()),
                ("snapshot_name", models.CharField(default="", max_length=32)),
                (
                    "vm",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="delete_snapshot_tasks",
                        to="vms.vm",
                    ),
                ),
            ],
            options={
                "abstract": False,
            },
            bases=("tasks.task",),
        ),
        migrations.CreateModel(
            name="CreateSnapshotTask",
            fields=[
                (
                    "task_ptr",
                    models.OneToOneField(
                        auto_created=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        parent_link=True,
                        primary_key=True,
                        serialize=False,
                        to="tasks.task",
                    ),
                ),
                ("name", models.CharField(default="", max_length=4096)),
                ("description", models.CharField(default="", max_length=4096)),
                ("lock_snapshot", models.CharField(max_length=10, null=True)),
                ("created_by", models.CharField(max_length=32, null=True)),
                ("replacement", models.BooleanField(default=False)),
                (
                    "vm",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="create_snapshot_tasks",
                        to="vms.vm",
                    ),
                ),
            ],
            options={
                "abstract": False,
            },
            bases=("tasks.task",),
        ),
        migrations.CreateModel(
            name="CloneVMTask",
            fields=[
                (
                    "task_ptr",
                    models.OneToOneField(
                        auto_created=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        parent_link=True,
                        primary_key=True,
                        serialize=False,
                        to="tasks.task",
                    ),
                ),
                ("vm_data", models.JSONField(default=dict)),
                ("vm_name", models.CharField(max_length=64)),
                (
                    "vm",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="clone_tasks",
                        to="vms.vm",
                    ),
                ),
            ],
            options={
                "abstract": False,
            },
            bases=("tasks.task",),
        ),
        migrations.CreateModel(
            name="CreateScheduledSnapshotTask",
            fields=[],
            options={
                "proxy": True,
                "indexes": [],
                "constraints": [],
            },
            bases=("tasks.createsnapshottask",),
        ),
    ]
