# Generated by Django 4.2.5 on 2024-01-18 16:21

import uuid

from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion
import encrypted_json_fields.fields

import systems.models
import vms.constants
from qlib.libvirt import get_default_machine
from vs.utils.time import get_utc_time


class Migration(migrations.Migration):
    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
        ("images", "0001_initial"),
        ("auth", "0012_alter_user_first_name_max_length"),
        ("cpus", "0001_initial"),
        ("pcigroup", "0001_initial"),
    ]

    operations = [
        migrations.CreateModel(
            name="VM",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "uuid",
                    models.CharField(db_index=True, max_length=36, null=True),
                ),
                (
                    "arch",
                    models.CharField(
                        choices=[("x86", "x86"), ("x64", "x64")],
                        default="x64",
                        max_length=3,
                    ),
                ),
                (
                    "bios",
                    models.CharField(
                        choices=[("seabios", "Legacy BIOS"), ("ovmf", "UEFI")],
                        max_length=16,
                    ),
                ),
                ("name", models.CharField(max_length=32)),
                ("cores", models.IntegerField()),
                ("memory", models.IntegerField()),
                (
                    "os_type",
                    models.CharField(default="generic", max_length=32),
                ),
                ("description", models.CharField(max_length=2048, null=True)),
                ("meta_path", models.CharField(max_length=4096, null=True)),
                ("boot_menu", models.BooleanField(default=False)),
                (
                    "auto_start_detach_device",
                    models.BooleanField(default=True),
                ),
                ("test", models.BooleanField(default=False)),
                ("libvirt_name", models.CharField(max_length=36)),
                (
                    "boot_order",
                    models.CharField(
                        choices=[
                            ("hd", "hd, cdrom"),
                            ("cdrom", "cdrom, hd"),
                            ("device", "order by device"),
                        ],
                        default="cdrom",
                        max_length=8,
                    ),
                ),
                ("keymap", models.CharField(default="en-us", max_length=16)),
                (
                    "cpu_model",
                    models.CharField(
                        choices=[
                            ("core2duo", "Intel(R) Core(TM)2 Duo CPU"),
                            (
                                "Nehalem",
                                "Intel Core i7 (Nehalem Class Core i7)",
                            ),
                            ("Westmere", "Intel Core i7 (Westmere)"),
                            (
                                "Opteron_G1",
                                "AMD Opteron 240 (Gen 1 Class Opteron)",
                            ),
                            (
                                "Opteron_G2",
                                "AMD Opteron 22xx (Gen 2 Class Opteron)",
                            ),
                            (
                                "Opteron_G5",
                                "AMD Opteron 63xx (Gen 5 Class Opteron)",
                            ),
                            ("host", "Passthrough"),
                        ],
                        max_length=20,
                    ),
                ),
                (
                    "machine",
                    models.CharField(
                        default=get_default_machine, max_length=20
                    ),
                ),
                (
                    "video_type",
                    models.CharField(
                        choices=[
                            ("none", "None"),
                            ("cirrus", "Cirrus"),
                            ("vga", "VGA"),
                            ("vmvga", "VMVGA"),
                            ("qxl", "QXL"),
                            ("virtio", "VirtIO"),
                            ("igpu", "iGPU"),
                        ],
                        max_length=16,
                    ),
                ),
                (
                    "last_video_type",
                    models.CharField(
                        choices=[
                            ("none", "None"),
                            ("cirrus", "Cirrus"),
                            ("vga", "VGA"),
                            ("vmvga", "VMVGA"),
                            ("qxl", "QXL"),
                            ("virtio", "VirtIO"),
                            ("igpu", "iGPU"),
                        ],
                        max_length=16,
                    ),
                ),
                (
                    "auto_start",
                    models.CharField(
                        choices=[
                            ("on", "Startup delay"),
                            ("quo", "Retain previous status"),
                            ("off", "None"),
                        ],
                        default="off",
                        max_length=16,
                    ),
                ),
                (
                    "auto_start_state",
                    models.CharField(
                        choices=[
                            ("stop", "stop"),
                            ("running", "running"),
                            ("suspended", "suspended"),
                        ],
                        default="stop",
                        max_length=16,
                    ),
                ),
                ("auto_start_delay", models.IntegerField(default=0)),
                (
                    "usb",
                    models.CharField(
                        choices=[("2", "USB 2.0"), ("3", "USB 3.0")],
                        max_length=16,
                    ),
                ),
                (
                    "sound",
                    models.CharField(
                        choices=[("ich6", "ICH6")], max_length=16, null=True
                    ),
                ),
                ("qvm", models.BooleanField(default=False)),
                ("rollback", models.TextField(null=True)),
                (
                    "snapshot_type",
                    models.CharField(default="external", max_length=8),
                ),
                (
                    "host_cpu",
                    models.CharField(
                        default=systems.models.get_host_cpu_name,
                        max_length=256,
                    ),
                ),
                (
                    "nas_model",
                    models.CharField(
                        default=systems.models.get_host_model_name,
                        max_length=50,
                    ),
                ),
                (
                    "channel_switch",
                    models.JSONField(
                        default=vms.constants.get_default_qemu_agent_config
                    ),
                ),
                ("hide_kvm_sign", models.BooleanField(default=False)),
                ("source", models.CharField(default="generic", max_length=50)),
                ("ballooning", models.IntegerField(default=0)),
                ("ballooning_rsvd", models.IntegerField(default=268435456)),
                ("hot_plug_cpu", models.BooleanField(default=False)),
                ("memory_sharing", models.BooleanField(default=True)),
                ("create_time", models.DateTimeField(null=True)),
                ("last_bootup_time", models.DateTimeField(null=True)),
                ("last_shutdown_time", models.DateTimeField(null=True)),
                ("last_suspend_time", models.DateTimeField(null=True)),
                (
                    "tpm_model",
                    models.CharField(
                        choices=[(None, "No TPM"), ("tpm-tis", "TPM TIS")],
                        default=None,
                        max_length=16,
                        null=True,
                    ),
                ),
                (
                    "cpuset",
                    models.ManyToManyField(
                        related_name="vms", to="cpus.cputhread"
                    ),
                ),
                (
                    "cpuset_policy",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="vms",
                        to="cpus.cpusetpolicy",
                    ),
                ),
            ],
            options={
                "permissions": (
                    ("control", "full control"),
                    ("view", "view"),
                    ("power", "power control"),
                    ("snapshot", "take snapshot"),
                    ("setting", "setting"),
                ),
            },
        ),
        migrations.CreateModel(
            name="Sharelink",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("sid", models.CharField(max_length=7, unique=True)),
                (
                    "protocol",
                    models.CharField(
                        choices=[("http", "HTTP"), ("https", "HTTPS")],
                        default="http",
                        max_length=32,
                    ),
                ),
                ("ip", models.CharField(default="", max_length=256)),
                ("port", models.IntegerField(default=80)),
                (
                    "create_at",
                    models.DateTimeField(default=get_utc_time),
                ),
                ("end_time", models.DateTimeField()),
                ("description", models.CharField(max_length=2048, null=True)),
                ("creater", models.CharField(max_length=150, null=True)),
                (
                    "vm",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="sharelinks",
                        to="vms.vm",
                    ),
                ),
            ],
            options={
                "abstract": False,
            },
        ),
        migrations.CreateModel(
            name="PCI",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("vendor", models.CharField(max_length=4)),
                ("device", models.CharField(max_length=4)),
                ("slot_id", models.CharField(max_length=16)),
                ("type", models.CharField(max_length=8)),
                (
                    "group",
                    models.ForeignKey(
                        null=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="pcis",
                        to="pcigroup.pcigroup",
                    ),
                ),
                (
                    "vm",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="pcis",
                        to="vms.vm",
                    ),
                ),
            ],
        ),
        migrations.CreateModel(
            name="VMUserObjectPermission",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "content_object",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="vm_permissions",
                        to="vms.vm",
                    ),
                ),
                (
                    "permission",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to="auth.permission",
                    ),
                ),
                (
                    "user",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
            ],
            options={
                "abstract": False,
                "unique_together": {("user", "permission", "content_object")},
            },
        ),
        migrations.CreateModel(
            name="USB",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("bus_num", models.IntegerField()),
                ("dev_num", models.IntegerField()),
                ("vendor_id", models.CharField(max_length=4)),
                ("product_id", models.CharField(max_length=4)),
                ("manufacturer", models.CharField(max_length=255, null=True)),
                ("product", models.CharField(max_length=255, null=True)),
                ("index", models.IntegerField(null=True)),
                ("boot_order", models.IntegerField(null=True)),
                (
                    "vm",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="usbs",
                        to="vms.vm",
                    ),
                ),
            ],
            options={
                "unique_together": {("vm", "bus_num", "dev_num")},
            },
        ),
        migrations.CreateModel(
            name="Graphic",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("type", models.CharField(default="vnc", max_length=8)),
                ("auto_port", models.BooleanField(default=True)),
                ("_port", models.IntegerField(null=True)),
                ("enable_password", models.BooleanField(default=False)),
                (
                    "password",
                    encrypted_json_fields.fields.EncryptedCharField(null=True),
                ),
                ("localhost_only", models.BooleanField(default=False)),
                ("enable", models.BooleanField(default=True)),
                (
                    "vm",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="graphics",
                        to="vms.vm",
                    ),
                ),
            ],
            options={
                "unique_together": {("vm", "type")},
            },
        ),
        migrations.CreateModel(
            name="Disk",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("path", models.CharField(max_length=4096)),
                ("root_path", models.CharField(max_length=4096)),
                ("size", models.BigIntegerField(null=True)),
                (
                    "format",
                    models.CharField(
                        choices=[
                            ("raw", "raw"),
                            ("qcow2", "qcow2"),
                            ("vmdk", "vmdk"),
                        ],
                        default="qcow2",
                        max_length=32,
                    ),
                ),
                (
                    "bus",
                    models.CharField(
                        choices=[
                            ("ide", "IDE"),
                            ("sata", "SATA"),
                            ("scsi", "SCSI"),
                            ("virtio", "Virtual Disk Controller"),
                            ("usb", "USB"),
                        ],
                        default="ide",
                        max_length=32,
                    ),
                ),
                ("dev", models.CharField(max_length=8, null=True)),
                (
                    "cache",
                    models.CharField(default="writeback", max_length=32),
                ),
                ("boot_order", models.IntegerField(null=True)),
                ("index", models.IntegerField(null=True)),
                (
                    "vm",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="disks",
                        to="vms.vm",
                    ),
                ),
            ],
            options={
                "unique_together": {("vm", "bus", "dev")},
            },
        ),
        migrations.CreateModel(
            name="CDROM",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("path", models.CharField(max_length=4096, null=True)),
                (
                    "bus",
                    models.CharField(
                        default=(("ide", "IDE"), ("scsi", "SCSI")),
                        max_length=32,
                    ),
                ),
                ("dev", models.CharField(max_length=8, null=True)),
                ("boot_order", models.IntegerField(null=True)),
                ("index", models.IntegerField(null=True)),
                (
                    "image",
                    models.ForeignKey(
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="cdroms",
                        to="images.image",
                    ),
                ),
                (
                    "vm",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="cdroms",
                        to="vms.vm",
                    ),
                ),
            ],
            options={
                "unique_together": {("vm", "bus", "dev")},
            },
        ),
        migrations.CreateModel(
            name="Adapter",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("mac", models.CharField(max_length=32)),
                ("bridge", models.CharField(max_length=16, null=True)),
                (
                    "model",
                    models.CharField(
                        choices=[
                            ("ne2k_pci", "NE2000"),
                            ("pcnet", "Pcnet32"),
                            ("rtl8139", "Realtek Fast Ethernet"),
                            ("e1000", "Intel Gigabit Ethernet"),
                            ("virtio", "Virtual Gigabit Ethernet"),
                        ],
                        default="e1000",
                        max_length=16,
                    ),
                ),
                ("index", models.IntegerField(null=True)),
                (
                    "type",
                    models.CharField(
                        choices=[
                            ("bridge", "Bridge"),
                            ("user", "NAT"),
                            ("vhostuser", "Vhost"),
                        ],
                        default="bridge",
                        max_length=9,
                    ),
                ),
                ("queues", models.IntegerField(default=1)),
                ("port_id", models.UUIDField(default=uuid.uuid4)),
                (
                    "vm",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="adapters",
                        to="vms.vm",
                    ),
                ),
            ],
            options={
                "unique_together": {("vm", "mac")},
            },
        ),
    ]
