
# PCI.factory flow charts

```mermaid
graph TD
Start[slot_id]
PCI[PCI CLASS]
PCI2[PCI CLASS]
SRIOV_PF[SRIOV_PF]
SRIOV_VF[SRIOV_VF]
Fail1[Fail]
Fail2[Fail]
Fail3[Fail]
Fail4[Fail]
Fail5[Fail]


D1{1. NAS PCI enabled}
D2{2. NAS SRIOV enabled}
D3{3. is registered class}
D4{4. is sriov pf<br>* has sriov_numvf<br>* sriov_numvf > 0}
D5{5. is normal pci<br>* not in NVS.vfs}
D6{6. is registered}
D7{7. is registered}


Start -->|get type| D1
D1 -->|Y| D2
D1 -->|N| Fail1

D2 -->|Y = pci, pf, vf| D4
D2 -->|N = pci| D3

D3 -->|Y| PCI
D3 -->|N| Fail2

D4 -->|Y| SRIOV_PF
D4 -->|N| D5

D5 -->|Y = pci| D6
D5 -->|N = vf| D7

D6 -->|Y| PCI2
D6 -->|N| Fail3


SRIOV_PF -->Fail4

D7 -->|Y| SRIOV_VF
D7 -->|N| Fail5

SRIOV_VF -->|VF| FIN
PCI -->|PCI| FIN
PCI2 -->|PCI| FIN
```

[Flowchart Syntax](http://knsv.github.io/mermaid/#flowcharts-basic-syntax)

